#!/bin/bash

# Dados de acesso Mysql
MYSQL_DB="" # Nome do banco de dados
MYSQL_USER="" # Usuário do banco de dados
MYSQL_PASSWORD="" # Senha do banco de dados
MYSQLDUMP_COMMAND="$(which mysqldump)"

# Diretório do backup
BACKUP_FOLDER="/backup"

# Perído em meses de remoção dos registros
PERIODO="1"

# Dados da conta FTP
FTP_HOST="" # Servidor FTP
FTP_USER="" # Usuário FTP
FTP_PASSWORD="" # Senha FTP

GZIP_COMMAND="$(which gzip)"

TIMESTAMP=$(date +%d%m%Y-%H%M%S)

[ ! -d $BACKUP_FOLDER ] && mkdir -p $BACKUP_FOLDER || /bin/rm -f $BACKUP_FOLDER/*

FILE=$BACKUP_FOLDER/$MYSQL_DB.$TIMESTAMP.gz

$MYSQLDUMP_COMMAND -u $MYSQL_USER -p$MYSQL_PASSWORD $MYSQL_DB | $GZIP_COMMAND -9 > $FILE

ftp -inv $FTP_HOST << EOF
user $FTP_USER $FTP_PASSWORD
lcd $BACKUP_FOLDER
put *
bye

EOF

mysql -u $MYSQL_USER -p$MYSQL_PASSWORD -D $MYSQL_DB -e "DELETE FROM tc_events WHERE serverTime < DATE_ADD(NOW(), INTERVAL -$PERIODO MONTH);"
mysql -u $MYSQL_USER -p$MYSQL_PASSWORD -D $MYSQL_DB -e "DELETE FROM tc_positions WHERE serverTime < DATE_ADD(NOW(), INTERVAL -$PERIODO MONTH);"
mysql -u $MYSQL_USER -p$MYSQL_PASSWORD -D $MYSQL_DB -e "UPDATE tc_devices SET positionId = NULL WHERE positionId NOT IN (SELECT id FROM tc_positions);"
rm -rf /opt/traccar/logs/*
rm -rf /tmp/*
shutdown -r now